var generalApiModule = require('./generalApiModule');

var SUPPORTEDPLATFORMS = generalApiModule.SUPPORTEDPLATFORMS;
var CONSTANTS = generalApiModule.CONSTANTS;
var GeneralAPI = generalApiModule.GeneralAPI;

var ViberAPI = function(bonoboToken, vToken = ""){

  var viberAPI = {};
  viberAPI.__proto__ = GeneralAPI(SUPPORTEDPLATFORMS.viber, bonoboToken);
  var viberToken = vToken;

  viberAPI.updateViberToken = function updateViberToken(newToken){
    viberToken = newToken;
  };

  function addAuthTokenToViberJson(dataToSend){
	if (dataToSend[CONSTANTS.FULL_JSON]["auth_token"] !== undefined &&
		dataToSend[CONSTANTS.FULL_JSON]["auth_token"] != viberToken &&
		dataToSend[CONSTANTS.FULL_JSON]["auth_token"] != ""){
	  viberToken = dataToSend[CONSTANTS.FULL_JSON]["auth_token"];
	}
    dataToSend[CONSTANTS.FULL_JSON]["auth_token"] = viberToken;
    return dataToSend;
  };

  viberAPI.sendDataToBonobo = function sendDataToBonobo(jsonData, timeDate = undefined, intentsList = undefined){
    generalApiModule.assertDictInput(jsonData);
    dataToSend = viberAPI.getBasicJson(jsonData, timeDate, intentsList);
    dataToSend = addAuthTokenToViberJson(dataToSend);
    content = viberAPI.sendToBonoboWithPOSTRequest(dataToSend)
    return content;
  };

  return viberAPI;
};

// exports module's class
module.exports.ViberAPI = ViberAPI;
